/****************************************************************************************/
/*	sxNew.cpp                                                                      		  */
/*                                                                                      */
/*  Author: D.R. Gunter                                                                	*/
/*  Description: Implementation for RFSX object generator     													*/
/*                                                                                      */
/*                                                                                      */
/*  See the accompanying file RealityFactory_Software_License.txt for terms 						*/
/*	on the use of this file. (Under "Reality Factory License")													*/
/*	Software distributed under the License is distributed on an "AS IS"                 */
/*  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See                */
/*  the License for the specific language governing rights and limitations              */
/*  under the License.                                                                  */
/*                                                                                      */
/****************************************************************************************/

#include "sxNew.h"

#ifdef SX_IMPL_TYPE
#undef SX_IMPL_TYPE
#endif
#define SX_IMPL_TYPE sxNew

namespace RFSX
{
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////
// sxNew implementation
//////////////////////////////////////////////////////////////////////////////////////////////////////////
	
SX_IMPL_TYPE::SX_IMPL_TYPE()
{

	;

}

SX_IMPL_TYPE::~SX_IMPL_TYPE()
{
	;
}

bool SX_IMPL_TYPE::method(const skString& m_name, skRValueArray& args, skRValue& r_val, skExecutableContext& ctxt)
{

	if(h_method(this, m_name, args, r_val, ctxt))
		return true;
	else return skExecutable::method(m_name, args, r_val, ctxt);
	
}
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////
// sxNew method functions
//////////////////////////////////////////////////////////////////////////////////////////////////////////
	
SX_METHOD_IMPL(Vector)
{
	skRValue::RType rtypes[] = {	skRValue::T_Float,
																skRValue::T_Float,
																skRValue::T_Float };

	if(!CheckParams(3, 3, args,  rtypes))
		return false;

	r_val.assignObject(new sxVector(args[0].floatValue(), args[1].floatValue(), args[2].floatValue()), true);
	return true;
}
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////
// sxNew initialization
//////////////////////////////////////////////////////////////////////////////////////////////////////////
	
SX_INIT_MHT(SXNEW_METHODS);
void SX_IMPL_TYPE::InitMHT()
{
	
	SX_ADD_METHOD(Vector);
	
}
	
} // namespace RFSX

#undef SX_IMPL_TYPE
