/****************************************************************************************/
/*	sxNew.cpp                                                                      		  */
/*                                                                                      */
/*  Author: D.R. Gunter                                                                	*/
/*  Description: Implementation for RFSX object generator     													*/
/*                                                                                      */
/*                                                                                      */
/*  See the accompanying file RealityFactory_Software_License.txt for terms 						*/
/*	on the use of this file. (Under "Reality Factory License")													*/
/*	Software distributed under the License is distributed on an "AS IS"                 */
/*  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See                */
/*  the License for the specific language governing rights and limitations              */
/*  under the License.                                                                  */
/*                                                                                      */
/****************************************************************************************/

#include "sxTEMPLATE.h"

#ifdef SX_IMPL_TYPE
#undef SX_IMPL_TYPE
#endif
#define SX_IMPL_TYPE sxTEMPLATE

namespace RFSX
{
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////
// sxTEMPLATE implementation -- 
//////////////////////////////////////////////////////////////////////////////////////////////////////////
	
SX_IMPL_TYPE::SX_IMPL_TYPE()
{

	;

}

SX_IMPL_TYPE::~SX_IMPL_TYPE()
{
	;
}

bool SX_IMPL_TYPE::method(const skString& m_name, skRValueArray& args, skRValue& r_val, skExecutableContext& ctxt)
{

	if(h_method(this, m_name, args, r_val, ctxt))
		return true;
	else return skExecutable::method(m_name, args, r_val, ctxt);
	
}


bool SX_IMPL_TYPE::getValue(const skString& name ,const skString& att, skRValue& val)
{
	if(name == "x")
	{
		val = (float)this->gVec()->X;
		return true;
	}	
	else if(name == "y")
	{
		val = (float)this->gVec()->Y;
		return true;
	}
	return skExecutable::getValue(name, att, val);
}	

bool SX_IMPL_TYPE::setValue(const skString& name ,const skString& att, const skRValue& val)
{
	if(name == "x")
	{
		gVec()->X = val.floatValue();
		return true;
	}
	if(name == "y")
	{
		gVec()->Y = val.floatValue();
		return true;
	}
	return skExecutable::setValue(name, att, val);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////
// sxTEMPLATE method functions -- add actual method processing code here
//////////////////////////////////////////////////////////////////////////////////////////////////////////
	
SX_METHOD_IMPL(name_of_method)
{
	skRValue::RType rtypes[] = {	skRValue::T_Float,
																skRValue::T_Float,
																skRValue::T_Float }; //parameter type list

	//if(!CheckParams(3, 3, args,  rtypes)) // uncomment for rigid type checking
		//return false;

	r_val.assignObject(new sxVector(args[0].floatValue(), args[1].floatValue(), args[2].floatValue()), true);
	return true;
}
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////
// sxTEMPLATE initialization
//////////////////////////////////////////////////////////////////////////////////////////////////////////
	
SX_INIT_MHT(SXNEW_METHODS);
void SX_IMPL_TYPE::InitMHT()
{
	
	// Add all methods here
	SX_ADD_METHOD(name_of_method);
	
}
	
} // namespace RFSX

#undef SX_IMPL_TYPE // And that's it in a nutshell
