/****************************************************************************************/
/*	sxNew.h                                                                   	     	  */
/*                                                                                      */
/*  Author: D.R. Gunter                                                                	*/
/*  Description: Class declaration for RFSX object generator.										        */
/*                                                                                      */
/*                                                                                      */
/*  See the accompanying file RealityFactory_Software_License.txt for terms 						*/
/*	on the use of this file. (Under "Reality Factory License")													*/
/*	Software distributed under the License is distributed on an "AS IS"                 */
/*  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See                */
/*  the License for the specific language governing rights and limitations              */
/*  under the License.                                                                  */
/*                                                                                      */
/****************************************************************************************/

// change these to your
#ifndef _SXTEMPLATE_H_
#define _SXTEMPLATE_H_


// include extra headers here
#include "RFSX.h"

#include "sxVector.h"

// sxTEMPLATE class definition
/*

	Description:
		(brief description of object goes here)
	
	Methods:
	//format: return_type Name(Param_type Param_name, ...)
		void	Name(int param1, float param2, sxVector v);
	
		Example(s):
		
	Fields:
	//type_codes: RO=Read-only WO=Write-only RW=Read/Write
	//format: type name(type_code);
		int some_value(RO);
		
*/

#ifdef SX_IMPL_TYPE
#undef SX_IMPL_TYPE
#endif
#define SX_IMPL_TYPE sxTEMPLATE

namespace RFSX
{
	
	class SX_IMPL_TYPE: public skExecutable
	{
		
		public:
			SX_IMPL_TYPE();
			virtual ~SX_IMPL_TYPE();
			static void InitMHT();
			
			virtual bool method(const skString& m_name, skRValueArray& args, skRValue& r_val, skExecutableContext& ctxt);
			virtual int executableType() { return RFSXG_NEW; };
			
		protected:
			// Add methods here, by name.
			SX_METHOD_DECL(MethodName);
			
		private:
			static sxMHT<SX_IMPL_TYPE> h_method;
		
	};
	
} // namespace RFSX

#undef SX_IMPL_TYPE

#endif // _RFSXNEW_H_
